#ifndef __LIBSMZY_IMPORT__
#define __LIBSMZY_IMPORT__

enum smzy_import_libso_errno{
	SMZY_IMPORT_LIB_OK = 0,
	SMZY_IMPORT_LIB_ERROR = 1,
	SMZY_IMPORT_LIB_NOPPSUFFIX, 
	SMZY_IMPORT_LIB_PPPATHERROR,
	SMZY_IMPORT_LIB_PPACCESSERROR,
	SMZY_IMPORT_LIB_PPNAMETOOLONG,
	SMZY_IMPORT_LIB_INSTALLPPERROR,
	SMZY_IMPORT_LIB_UPPPERROR,
	SMZY_IMPORT_LIB_SYSTEMFUNERROR,
	SMZY_IMPORT_LIB_GETTPMERROR,
	SMZY_IMPORT_LIB_CREATTPMERROR,
	SMZY_IMPORT_LIB_EXSECPERROR,
	SMZY_IMPORT_LIB_OPENSECPERROR,
	SMZY_IMPORT_LIB_GETJSONERROR,
	SMZY_IMPORT_LIB_PATHFORMATERROR,
	SMZY_IMPORT_LIB_GETPPNAMEERROR,
	SMZY_IMPORT_LIB_BUFTOOSMALL,
	SMZY_IMPORT_LIB_IMPORTPPERROR,
	SMZY_IMPORT_LIB_INSERTSTYPEERROR,
	SMZY_IMPORT_LIB_CLEANTMPERROR,
	SMZY_IMPORT_LIB_INSERT_PKILLERROR,
	SMZY_IMPORT_LIB_GETPKILLERROR,
	SMZY_IMPORT_LIB_RM_SOFTFILETYPEERROR,
	SMZY_IMPORT_LIB_RM_PKILLERROR,
	SMZY_IMPORT_LIB_RM_SECSOFTERROR,
	SMZY_IMPORT_LIB_RM_PROTECTDIRERROR,
	SMZY_IMPORT_LIB_FCNOTFOUND,
	SMZY_IMPORT_LIB_FCCANNOTOPEN,
	SMZY_IMPORT_LIB_FCMULTIPLE,
	SMZY_IMPORT_LIB_TENOTFOUND,
	SMZY_IMPORT_LIB_TECANNOTOPEN,
	SMZY_IMPORT_LIB_GLBMULTIPLE,
	SMZY_IMPORT_LIB_RMPPERROR,
	SMZY_IMPORT_LIB_INSTOKSTYPEERROR,
	SMZY_IMPORT_LIB_INSTOKSOFTDIRERROR,
	SMZY_IMPORT_LIB_INSTOKPROTECTERROR,
	SMZY_IMPORT_LIB_INSTOKPKILLERROR,
	SMZY_IMPORT_LIB_RM_OLD_PP_ERR,
	SMZY_IMPORT_LIB_MAKE_NEW_PP_ERR,
	SMZY_IMPORT_LIB_ERROR_END,
};


/*
错误码						   错误值	英文错误信息						中文错误信息 					注释
-------------------------------------------------------------------------------------------------------------------------------------------------
SMZY_IMPORT_LIB_OK					0	Success								成功
SMZY_IMPORT_LIB_ERROR				1	Error								错误
SMZY_IMPORT_LIB_NOPPSUFFIX 			2	No suffix pp						没有pp后缀或者文件后缀错误
SMZY_IMPORT_LIB_PPPATHERROR			3	pp path format error				pp文件路径格式错误
SMZY_IMPORT_LIB_PPACCESSERROR		4	can not access pp file				无法访问pp文件
SMZY_IMPORT_LIB_PPNAMETOOLONG		5	pp file name is too long			pp文件名称过长
SMZY_IMPORT_LIB_INSTALLPPERROR		6	install pp failed					安装pp错误
SMZY_IMPORT_LIB_UPPPERROR			7	update pp failed					升级pp错误
SMZY_IMPORT_LIB_SYSTEMFUNERROR		8	system function run error			system 函数运行失败
SMZY_IMPORT_LIB_GETTPMERROR			9	get tmp path error					获取临时目录名称错误
SMZY_IMPORT_LIB_CREATTPMERROR		10	create tmp path error				创建临时路径失败
SMZY_IMPORT_LIB_EXSECPERROR			11	unzip secp file failed				解压secp失败 					此时临时路径已经创建，情清理临时目录
SMZY_IMPORT_LIB_OPENSECPERROR		12	open secp data.json error			打开data.json文件失败 			此时临时路径已经创建，情清理临时目录
SMZY_IMPORT_LIB_GETJSONERROR		13	get json format error				获取json信息失败 				此时临时路径已经创建，情清理临时目录
SMZY_IMPORT_LIB_PATHFORMATERROR		14	file path formar error				文件路径格式错误
SMZY_IMPORT_LIB_GETPPNAMEERROR		15	get pp name error					获取pp名称失败
SMZY_IMPORT_LIB_BUFTOOSMALL			16	BUF too small						接收buf空间太小
SMZY_IMPORT_LIB_IMPORTPPERROR		17	import pp error						导入pp失败
SMZY_IMPORT_LIB_INSERTSTYPEERROR	18	insert trusted software list error	插入可信列表错误
SMZY_IMPORT_LIB_CLEANTMPERROR		19	clean tmp error						清理临时目录出错
SMZY_IMPORT_LIB_INSERT_PKILLERROR 	20	insert prevent kill error 			添加进程防杀死失败 			
SMZY_IMPORT_LIB_GETPKILLERROR		21	get prevent kill form json error 	获取防杀死信息失败 				此时临时路径已经创建，情清理临时目录      
SMZY_IMPORT_LIB_RM_SOFTFILETYPEERROR 22	remove file protection error		移除文件保护失败 
SMZY_IMPORT_LIB_RM_PKILLERROR		23	remove precess kill prevention error 移除进程防杀死失败
SMZY_IMPORT_LIB_RM_SECSOFTERROR		24	remove security software label error 安全软件标签失败
SMZY_IMPORT_LIB_RM_PROTECTDIRERROR 	25 	remove protect dir lable error 		移除防删除目录标签失败
SMZY_IMPORT_LIB_FCNOTFOUND 			26 	fc not found 						没有找到fc文件
SMZY_IMPORT_LIB_FCCANNOTOPEN 		27 	fc can not openlog 					无法打开fc文件
SMZY_IMPORT_LIB_FCMULTIPLE 			28 	fc multiple public definitions 		标记重复定义
SMZY_IMPORT_LIB_TENOTFOUND 			29 	te not found 						没有找到te文件
SMZY_IMPORT_LIB_TECANNOTOPEN 		30 	te can not open 					无法打开te文件
SMZY_IMPORT_LIB_GLBMULTIPLE 		31 	global tag declarations repeat 		全局标签重复声明
SMZY_IMPORT_LIB_RMPPERROR			32	remove pp failed					卸载pp错误
SMZY_IMPORT_LIB_INSTOKSTYPEERROR 	33 	enable stype to kernel failed 				生效安全软件标签失败
SMZY_IMPORT_LIB_INSTOKSOFTDIRERROR 	34 	enable soft file type kernel failed  		生效软件保护文件标签失败
SMZY_IMPORT_LIB_INSTOKPROTECTERROR 	35 	enable protect dir type to kernel failed 	生效目录保护标签失败 
SMZY_IMPORT_LIB_INSTOKPKILLERROR 	36 	enable pervent kill type to kernel failed 	生效防杀死标签失败
SMZY_IMPORT_LIB_RM_OLD_PP_ERR 		37	remove old pp error 				删除旧pp文件失败
SMZY_IMPORT_LIB_MAKE_NEW_PP_ERR 	38	make new pp error 					编译更新pp文件失败
SMZY_IMPORT_LIB_ERROR_END			37	NULL								NULL 							字典边界 										 
-------------------------------------------------------------------------------------------------------------------------------------------------
*/

/*
 * 功能：解压secp打包文件，并获取相关信息
 * 传参：
 * 		secpfile_path: secp 文件完整路径
 * 		passwd: secp文件密码
 *		tmp_dir: 接收临时解压缩路经的buf指针，建议空间不小于256字节
 *		len_tmp_dir：接收临时解压缩路经的buf大小
 *		readme：接收放权客体信息的buf指针，建议空间不小于4096字节
 *		len_readme：接收放权客体信息的buf大小
 *	  	返回值: 成功返回零；出错返回负数，具体信息 通过 get_smzy_import_libso_errmsg 获取
 * */
extern int policy_cont(
 		const char *secpfile_path,
		const char *passwd,
		char tmp_dir[],
		int len_tmp_dir,
		char readme[],
		int len_readme
		);

/*
 * 功能：清理临时目录 
 * 传参：
 * 		tmp_dir:要清理的目录路径
 * 返回值：成功返回0；失败返回负数
 * */
extern int clean_tmp_dir(char *tmp_dir);


/*
 * 功能：导入策略规则并添加新可信软件主体
 * 传参：
 * 		tmp_dir：要导入的安全配置所在的临时文件路径,请填写完整路径
 * 返回值: 成功返回零；出错返回负数，具体信息 通过 get_smzy_import_libso_errmsg 获取
 * */
extern int policy_op(char * tmp_dir);





/*
 * 功能：打开并解压secp文件到tmp目录
 * 参数：
 * 		secpfile_path:secp文件路径
 * 		passwd:secp密码
 * 		secp_tmp_dir:用于保存返回secp文件的解压路径 建议buf大小不小于256字节
 * 		len_tmp_dir:secp_tmp_dir 空间长度 
 * 返回值: 成功返回零；出错返回负数，具体信息 通过 get_smzy_import_libso_errmsg 获取
 * */
extern int secp_open(const char *secpfile_path,const char *passwd,char secp_tmp_dir[],int len_tmp_dir);


/*
 * 功能：通过解压路径，比对已解压的secp文件
 * 参数：
 * 		secp_temp_dir1:被比对路径1
 * 		secp_temp_dir2:被比对路径2
 * 返回值: 	未找到冲突返回0
 * 		 	找到冲突返回正数，返回值含义如下	
 * 								SMZY_IMPORT_LIB_FCMULTIPLE ：secp标记定义重复
 *
 * 		  	出错返回负数，具体信息 通过 get_smzy_import_libso_errmsg 获取
 * 说明：
 * 		首先通过 secp_open 解压两个要比对的secp文件
 * 		再通过secp_cmp_by_path 进行比对，为提高多文件比对效率比，比对结束后临时路径内容不会自动清理
 * 		调用后请自行定夺调用 clean_tmp_dir 清理临时路径
 * */
extern int secp_cmp_by_path(const char *secp_temp_dir1,const char *secp_temp_dir2);


/*
 * 功能：比对未解压的secp路径
 * 参数：
 * 		secp1:比对文件1
 * 		secp2:比对文件2
 * 		passwd:secp 密码
 * 返回值: 	未找到冲突返回0
 * 		 	找到冲突返回正数，返回值含义如下	
 * 								SMZY_IMPORT_LIB_FCMULTIPLE ：secp标签多重定义
 * 								SMZY_IMPORT_LIB_GLBMULTIPLE: secp全局标签重复声明
 * 		  	出错返回负数，具体信息 通过 get_smzy_import_libso_errmsg 获取
 * */
extern int secp_cmp_by_file(const char *secp1,const char *secp2,const char *passwd);


/*
 * 功能：插入secp安全配置到系统中，并返回放行资源信息。
 * 传参：
 * 		secpfile_path: secp文件完整路径
 *		readme：接收放权客体信息的buf指针，建议空间不小于4096字节
 *		len_readme：接收放权客体信息的buf大小
 *
 * 返回值: 成功返回零；出错返回负数，具体信息 通过 get_smzy_import_libso_errmsg 获取
 * */
extern int policy_secp_insert(const char *secpfile_path,char readme[],int len_readme);


/*
 * 功能：移除以存在的secp安全配置
 * 参数：
 * 		 secpfile_path:安装时的secp文件
 * 返回值: 成功返回零；出错返回负数，具体信息 通过 get_smzy_import_libso_errmsg 获取
 * */
extern int policy_secp_remove(const char *secpfile_path);


/*
 * 功能：比对未解压的secp路径
 * 参数：
 * 		secp1:比对文件1
 * 		secp2:比对文件2
 * 返回值: 	未找到冲突返回0
 * 		 	找到冲突返回正数，返回值含义如下	
 * 								SMZY_IMPORT_LIB_FCMULTIPLE ：secp标签多重定义
 * 								SMZY_IMPORT_LIB_GLBMULTIPLE: secp全局标签重复声明
 * 		  	出错返回负数，具体信息 通过 get_smzy_import_libso_errmsg 获取
 * */
extern int policy_secp_cmp(const char *secp1,const char *secp2);


/*
 * 功能：通过函数返回值获取错误信息
 * 传参：
 * 		 type：函数返回的错错误值
 * 		 desplay_ch: 0 返回英文提示信息；非零 返回中文错误值
 * 返回值：错误值可识别，返回对应的错误信息字符串常量；否则返回NULL
 * */
extern const char *get_smzy_import_libso_errmsg(int type,int desplay_ch);





/* 
 * 注释：如果发生错误情使用 get_smzy_import_libso_errmsg
 * 			提取错误信息并打印到日至
 * */

#endif

